/*
 *	20170721-04-9999.c
 *	Fizz Buzz
 */

#include <stdio.h>
#include "s_print.h"

/*
 * <a href="http://ja.wikipedia.org/wiki/Fizz_Buzz"> Fizz Buzz (フィズ・バズ) </a>
 *   最初は「1」と数値を発言。次は次の数値を発言。
 *   ただし、 2 で割り切れる場合は 「Fizz」、
 *   7 で割り切れる場合は 「Buzz」、
 *   両者で割り切れる場合は 「Fizz Buzz」を数値の代わりに発言しなければならない。
 */

void fizz_buzz ( int n ) {

	if ( n % 2 == 0 ) {	/* 2 で割切れた */
		if ( n % 7 == 0 ) {	/* 更に 7 で割切れた */
			/* 2 でも 7 でも割切れるから .. */
			s_print_string ( "Fizz Buzz" );
		} else {		/* 2 で割れるが 7 で割切れないので.. */
			s_print_string ( "Fizz" );		/* Fizz だけでよい */
		}
	} else if ( n % 7 == 0 ) { 	/* 2 で割切れずに 7 で割切れたので.. */
		s_print_string ( "Buzz" );
	} else {			/* いずれでもなければ、2, 7 共に割切れない */
 		s_print_int ( n );
	}
}

/*
 * fizz_buzz_i_to_n
 */

void fizz_buzz_i_to_n ( int i, int n ) {

  if ( i > n ) {			/* すでに n まで書いた */
	/* 何もする事はない */
  } else {					/* まだ、やる事がある */
	fizz_buzz ( i );		/* とりあえず i の処理 */
	s_print_string ( " " );	/* 隙間 */
				   			/* 残りは再帰で */
	fizz_buzz_i_to_n ( i + 1, n );
  }

}

/*
 *	main
 */

int main( int argc, char *argv[] ) {

  fizz_buzz_i_to_n ( 1, 199 );
  s_print_newline();

  return 0;
}

/*
 *
 */

